<?php

// Authors: 
//		Brian N. Smith  -      NuOnce Networks      - http://www.nuonce.net
//		Michael Stauber - Stauber Multimedia Design - http://www.solarspeed.net
// Copyright 2006, NuOnce Networks & Stauber Multimedia Design. All rights reserved.
// Tue 20 Feb 2007 05:41:06 AM EST mstauber  v1.1.0.0
//

include("ServerScriptHelper.php");
include_once('AutoFeatures.php');
include_once('Capabilities.php');

$serverScriptHelper = new ServerScriptHelper();
$i18n = $serverScriptHelper->getI18n("vz-wizard");

//Only users with adminUser or ManageVPS capability should be here
include("0_vps_access.inc.php");

// URL string validation:
// Common sense stuff. $vpsid MUST not be empty and it must match an existing VPS ID.
// If this is not the case, we return a forbidden error.

if (!$vpsid) {
    header("location: /error/forbidden.html");
    return;
}
if ($errors) {
    $old_errors = $errors;
}

// First of all we need to update the abbreviated ressource info.
// For that purpose we write something into CCE and henceforth
// trigger a handler that will update the info in CCE:

        $helper =& new ServerScriptHelper($sessionId);
        $cceHelper =& $helper->getCceClient();
        $masternodeOID = $cceHelper->find("VserverMasterNode");

        // Virtual Private Server: Main Settings
        $cceHelper->set($masternodeOID[0], "",
                array(
                        'gui_list_ip' => $vpsid,
                        'gui_list_all' => time()
                )
         );
        $errors = $cceHelper->errors();

//

$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("vz-vserver", "/vz/vserver/vserverRestoreAction.php");
$transMethodOn="off";

$oids = $cceClient->findx('Vserver');
$vpsexists = 0;
foreach ($oids as $oid) {
    $vpsinfo = $cceClient->get($oid);
    if ($vpsinfo['vpsid'] == $vpsid ) {
	$vpsexists = 1;
    }
}
if ($vpsexists == 0) {
    header("location: /error/forbidden.html");
    return;
}

if (($action != "localrestore") && ($action != "remoterestore")) {
    header("location: /error/forbidden.html");
    return;
}

// get VPS information out of CCE:
$num = 1;
$oids = $cceClient->findx('Vserver', array('vpsid' => $vpsid));
foreach ($oids as $oid) {                
    $vpsinfo = $cceClient->get($oid);
    if ($vpsinfo['vpsid']) {         
        $vserverlist[$num] = array(  
            'vpsid' => $vpsinfo['vpsid'],
            'ip' => $vpsinfo['ip'],      
            'hostname' => $vpsinfo['hostname'],
            'status' => $vpsinfo['status'],
            'numproc' => $vpsinfo['numproc'],
            'laverage' => $vpsinfo['laverage'],
            'suspend' => $vpsinfo['suspend'],
            'cpuunits' => $vpsinfo['cpuunits'],
            'name' => $vpsinfo['name'],
            'ONBOOT' => $vpsinfo['ONBOOT'],
            'basedir' => $vpsinfo['basedir'],
            'name' => $vpsinfo['name']
        );
        $num++;
    }
}

// Prepare Page generation:
$page = $factory->getPage();

// Get vserver list table pre-arranged:
if ($action == "localrestore") {
    if ($is_adminUser == "1") {
    	$vserverdisplay = $factory->getScrollList("vserverLOCAL_RESTORE_HEAD", array("vpsid", "IP-Address", "Hostname", "Status", "Processes", "Load Average", "CPU Units", "onboot", "Owner"), array(0,1,2,3,4,5,6,7,8));
    }
    else {
    	$vserverdisplay = $factory->getScrollList("vserverLOCAL_RESTORE_HEAD", array("IP-Address", "Hostname", "Status", "Processes", "Load Average", "CPU Units", "onboot", "Owner"), array(0,1,2,3,4,5,6,7));
    }
}
if ($action == "remoterestore") {
    if ($is_adminUser == "1") {
    	$vserverdisplay = $factory->getScrollList("vserverREMOTE_RESTORE_HEAD", array("vpsid", "IP-Address", "Hostname", "Status", "Processes", "Load Average", "CPU Units", "onboot", "Owner"), array(0,1,2,3,4,5,6,7,8));
    else {
    	$vserverdisplay = $factory->getScrollList("vserverREMOTE_RESTORE_HEAD", array("IP-Address", "Hostname", "Status", "Processes", "Load Average", "CPU Units", "onboot", "Owner"), array(0,1,2,3,4,5,6,7));
    }
}
$vserverdisplay->setDefaultSortedIndex(0);

if ($action == "localrestore") {
    $vserverdisplay->addButton($factory->getButton("/vz/vserver/vserverRestoreConfirm.php?vpsid=$vpsid&action=localrestore", "vserverLocalRestoreYES"));
}
if ($action == "remoterestore") {
    $vserverdisplay->addButton($factory->getButton("/vz/vserver/vserverRestoreConfirm.php?vpsid=$vpsid&action=remoterestore", "vserverRemoteRestoreYES"));
}

$serverScriptHelper->destructor();

print($page->toHeaderHtml());
?>
<SCRIPT LANGUAGE="javascript">
/*
 * if you change this function, update it in advancedSearch.php too.
 * It is split, because for some reason it works better to have it
 * output directly instead of as a function.  Who knows why?
 */
function openSiteMgmt(server, fqdn, title)
{
        var serverManageItem = top.siteMap["vz_serveradmin"];

        // go through all descendents to substitute all [[VAR]] properties
        var items = new Array();
        items[0] = serverManageItem;

        // set the visibility to true, so things show up
        serverManageItem.setVisible(true, true);

        while (items.length > 0) {
                var item = items[items.length-1];
                items.length--;

                /*
                 * FIX ME
                 * substitute all other item properties and variables as well
                 */
                var tag = "[[VAR.vpsid]]";
                var tag2 = "[[VAR.hostname]]";
                var tag3 = "[[VAR.title]]";

                // Substitue vars into URL
                if (item.origUrl == null) {
                        item.origUrl = item.getUrl();
                }
                var origUrl = item.origUrl;
                if((origUrl.indexOf(tag) != -1) ||
                   (origUrl.indexOf(tag2) != -1) ||
                   (origUrl.indexOf(tag3) != -1)) {
                        item.setUrl(
                            top.code.string_substitute(origUrl, tag, server, tag2,
                                                       fqdn, tag3, title));
                }

                // Substitue vars into description
                if (item.origDesc == null) {
                        item.origDesc = item.getDescription();
                }
                var origDesc = item.origDesc;
                if((origDesc.indexOf(tag) != -1) ||
                   (origDesc.indexOf(tag2) != -1) ||
                   (origDesc.indexOf(tag3) != -1)) {
                        item.setDescription(
                            top.code.string_substitute(origDesc, tag, server,
                                                       tag2, fqdn, tag3,
                                                       title));
                }

                // Substitue vars into label
                if (item.origName == null) {
                        item.origName = item.getName();
                }
                var origName = item.origName;
                if((origName.indexOf(tag) != -1) ||
                   (origName.indexOf(tag2) != -1) ||
                   (origName.indexOf(tag3) != -1)) {
                        item.setName(
                            top.code.string_substitute(origName, tag, server,
                                                       tag2, fqdn, tag3,
                                                       title));
                }

                // add children to the list
                var children = item.getItems();
                for (var i = 0; i < children.length; i++) {
                        items[items.length] = children[i];
                }
        }

        top.code.cList_setRoot(serverManageItem);
        /*
          this is essentially doing a .5 second sleep before running the selectPath.
          that's because some browsers encounter race conditions when running our javascript
          and will fail to display the new menu unless we put in a sleep.
        */
        setTimeout('top.code.cList_selectPath(\"vz_vserver_modify\")', 500);
}

</SCRIPT>
<?php

// Populate table rows with the data:
$oldnum = $num;
while ( $num > 0 ) {
    if ($vserverlist[$num]['vpsid']) {

	// Actions = Add the buttons to view, modify and delete vservers:
	$actions = $factory->getCompositeFormField();
	$vpsid = $vserverlist[$num]['vpsid'];
	$fqdn  = $vserverlist[$num]['hostname'];
	$detailButton = $factory->getDetailButton("/vz/vserver/vserverInfo.php?vpsid=$vpsid");
	$actions->addFormField($detailButton);
	$modifyButton = $factory->getModifyButton("/vz/vserver/vserverModify.php?vpsid=$vpsid");
	$actions->addFormField($modifyButton);
	$removeButton = $factory->getRemoveButton("/vz/vserver/vserverDelete.php?vpsid=$vpsid");
	$actions->addFormField($removeButton);

	// Actual table row information:
        if ($is_adminUser == "1") {
            $vserverdisplay->addEntry(array(
                $factory->getTextField("", $vserverlist[$num]['vpsid'], "r"),
                $factory->getTextField("", $vserverlist[$num]['ip'], "r"),
                $factory->getTextField("", $vserverlist[$num]['hostname'], "r"),
                $factory->getTextField("", $vserverlist[$num]['status'], "r"),
                $factory->getTextField("", $vserverlist[$num]['numproc'], "r"),
                $factory->getTextField("", $vserverlist[$num]['laverage'], "r"),
                $factory->getTextField("", $vserverlist[$num]['cpuunits'], "r"),
                $factory->getTextField("", $vserverlist[$num]['ONBOOT'], "r"),
                $factory->getTextField("", $vserverlist[$num]['name'], "r"),
                $actions
            ));
        }
        else {
            $vserverdisplay->addEntry(array(
                $factory->getTextField("", $vserverlist[$num]['ip'], "r"),
                $factory->getTextField("", $vserverlist[$num]['hostname'], "r"),
                $factory->getTextField("", $vserverlist[$num]['status'], "r"),
                $factory->getTextField("", $vserverlist[$num]['numproc'], "r"),
                $factory->getTextField("", $vserverlist[$num]['laverage'], "r"),
                $factory->getTextField("", $vserverlist[$num]['cpuunits'], "r"),
                $factory->getTextField("", $vserverlist[$num]['ONBOOT'], "r"),
                $factory->getTextField("", $vserverlist[$num]['name'], "r"),
                $actions
            ));
        }
    }
    $num--;
}

// Out with the populated table:
echo $vserverdisplay->toHtml();
print "<input type=\"hidden\" name=\"vpsid\" value=\"" . $vpsid . "\">"; // $vpsid needs to be passed back.

$GLOBALS["_FormField_width"] = 16;

// Print Footer:
echo $page->toFooterHtml(); 

?>

